PROGRAM RIDUCI_a_GARANZIA;
uses crt;

const rid:array[1..20,1..6] of byte =
        ((1,2,3,4,5,6),    (1,2,7,8,9,10),     (1,2,11,12,13,14),
         (1,2,15,16,17,18),(3,4,9,10,11,12),   (3,4,13,14,15,16),
         (3,5,8,10,15,18), (4,6,8,10,16,17),   (5,6,7,8,11,12),
         (5,6,13,14,17,18),(7,8,9,10,11,12),   (13,14,15,16,17,18),
         (1,2,7,8,13,14),  (3,4,9,10,15,16),   (1,4,7,10,13,16),
         (2,5,8,11,14,17), (3,6,9,12,15,18),   (1,4,8,11,15,18),
         (2,5,9,12,13,16), (3,6,7,10,14,17));

var sis:array [0..90] of byte;
    col:array [1..20,1..6] of byte;

procedure fine;
var f:file;
begin
 assign(f,'finito.ok'); rewrite(f,1); close(f);
end;

procedure riduci;
var i,j:integer;
begin
 for i:=1 to 20 do
 begin
  for j:=1 to 6 do col[i,j]:=sis[rid[i,j]];
 end;
end;

procedure carica_sistema;
var maxs:longint;
    f:file;
begin
 assign(f,'sistema.dat'); reset(f,1);
 if ioresult<>0 then begin sis[0]:=0; fine; exit; end;
 maxs:=filesize(f); if maxs>91 then maxs:=91;
 blockread(f,sis[0],maxs);
 close(f);
end;

procedure registra_colonne;
var b:longint;
    f:file;
begin
 assign(f,'colonne.dat'); rewrite(f,1);
 b:=20; blockwrite(f,b,4);
 blockwrite(f,col[1,1],20*6);
 close(f);
end;

var key:char;

BEGIN
 TEXTCOLOR(15); TEXTBACKGROUND(0); CLRSCR; textcolor(8);
 GOTOXY(44,25); WRITE('By Antioco Fonnesu: anti@freeweb.org'); textcolor(15);
 carica_sistema;
 if sis[0]<>18 then
 begin
  gotoxy(1,1);
  writeln('Errore: questa funzione riduce a garanzia del 3 solo i sistemi da 18 numeri.');
  writeln('Correggere e riprovare.');
  writeln('- Premi un tasto -');
  while keypressed do key:=readkey;
  repeat key:=readkey; until keypressed=false;
  fine; exit;
 end;
 riduci;
 registra_colonne;
 fine;
END.