PROGRAM RIDUCI_a_GARANZIA;
uses crt;

const rid:array[1..30,1..6] of byte =
        ((1,2,3,4,5,6),    (1,2,7,8,9,10),     (1,2,11,12,13,14),
         (1,2,15,16,17,18),(1,3,7,11,15,19),   (1,3,8,12,16,20),
         (1,4,7,13,17,20), (1,4,8,14,18,19),   (1,5,9,11,18,20),
         (1,5,10,12,17,19),(1,6,9,13,16,19),   (1,6,10,14,15,20),
         (2,3,7,14,18,20), (2,3,8,13,17,19),   (2,4,7,12,16,19),
         (2,4,8,11,15,20), (2,5,9,14,15,19),   (2,5,10,13,16,20),
         (2,6,9,12,17,20), (2,5,10,11,18,19),  (3,4,9,10,11,12),
         (3,4,13,14,15,16),(3,5,7,9,16,17),    (3,5,8,10,15,18),
         (4,6,7,9,15,18),  (4,6,8,10,16,17),   (5,6,7,8,11,12),
         (5,6,13,14,17,18),(11,14,16,17,19,20),(12,13,15,18,19,20));

var sis:array [0..90] of byte;
    col:array [1..30,1..6] of byte;

procedure fine;
var f:file;
begin
 assign(f,'finito.ok'); rewrite(f,1); close(f);
end;

procedure riduci;
var i,j:integer;
begin
 for i:=1 to 30 do
 begin
  for j:=1 to 6 do col[i,j]:=sis[rid[i,j]];
 end;
end;

procedure carica_sistema;
var maxs:longint;
    f:file;
begin
 assign(f,'sistema.dat'); reset(f,1);
 if ioresult<>0 then begin sis[0]:=0; fine; exit; end;
 maxs:=filesize(f); if maxs>91 then maxs:=91;
 blockread(f,sis[0],maxs);
 close(f);
end;

procedure registra_colonne;
var b:longint;
    f:file;
begin
 assign(f,'colonne.dat'); rewrite(f,1);
 b:=30; blockwrite(f,b,4);
 blockwrite(f,col[1,1],30*6);
 close(f);
end;

var key:char;

BEGIN
 TEXTCOLOR(15); TEXTBACKGROUND(0); CLRSCR; textcolor(8);
 GOTOXY(44,25); WRITE('By Antioco Fonnesu: anti@freeweb.org'); textcolor(15);
 carica_sistema;
 if sis[0]<>20 then
 begin
  gotoxy(1,1);
  writeln('Errore: questa funzione riduce a garanzia del 3 solo i sistemi da 20 numeri.');
  writeln('Correggere e riprovare.');
  writeln('- Premi un tasto -');
  while keypressed do key:=readkey;
  repeat key:=readkey; until keypressed=false;
  fine; exit;
 end;
 riduci;
 registra_colonne;
 fine;
END.