PROGRAM RIDUCI_a_GARANZIA;
uses crt;

const rid:array[1..35,1..6] of byte =
         ((1,4,7,10,13,15),(1,5,8,12,15,16),(1,6,8,10,15,17),
           (2,4,7,12,15,17),(2,4,8,10,14,16),(2,5,8,11,14,17),
            (2,6,7,11,15,16),(2,6,9,10,13,17),(3,4,8,12,13,17),
            (3,4,9,10,15,16),(3,5,7,12,14,16),(3,5,9,11,15,17),
            (3,6,7,10,14,17),(3,6,8,11,13,16),(4,5,6,7,8,9),
            (4,5,6,13,14,15),(7,8,9,10,11,12),(10,11,12,13,14,15),
            (1,2,4,9,11,13),(2,3,5,7,10,15),(1,3,4,7,11,14),
            (1,5,7,11,13,17),(2,5,9,12,13,16),(4,5,10,11,16,17),
            (2,3,4,6,11,12),(7,8,9,13,14,15),(1,9,12,14,16,17),
            (1,3,6,9,12,15),(1,2,3,6,16,17),(1,4,5,6,9,14),
            (1,2,6,10,12,13),(1,3,5,9,10,14),(2,3,13,14,16,17),
            (3,6,7,8,12,14),(6,10,11,12,16,17));

var sis:array [0..90] of byte;
    col:array [1..35,1..6] of byte;

procedure fine;
var f:file;
begin
 assign(f,'finito.ok'); rewrite(f,1); close(f);
end;

procedure riduci;
var i,j:integer;
begin
 for i:=1 to 35 do
 begin
  for j:=1 to 6 do col[i,j]:=sis[rid[i,j]];
 end;
end;

procedure carica_sistema;
var maxs:longint;
    f:file;
begin
 assign(f,'sistema.dat'); reset(f,1);
 if ioresult<>0 then begin sis[0]:=0; fine; exit; end;
 maxs:=filesize(f); if maxs>91 then maxs:=91;
 blockread(f,sis[0],maxs);
 close(f);
end;

procedure registra_colonne;
var b:longint;
    f:file;
begin
 assign(f,'colonne.dat'); rewrite(f,1);
 b:=35; blockwrite(f,b,4);
 blockwrite(f,col[1,1],35*6);
 close(f);
end;

var key:char;

BEGIN
 TEXTCOLOR(15); TEXTBACKGROUND(0); CLRSCR; textcolor(8);
 GOTOXY(44,25); WRITE('17 numeri a garanzia di un 4 con 6 estratti'); textcolor(15);
 carica_sistema;
 if sis[0]<>17 then
 begin
  gotoxy(1,1);
  writeln('Errore: questa funzione riduce a garanzia del 4 solo i sistemi da 17 numeri.');
  writeln('Correggere e riprovare.');
  writeln('- Premi un tasto -');
  while keypressed do key:=readkey;
  repeat key:=readkey; until keypressed=false;
  fine; exit;
 end;
 riduci;
 registra_colonne;
 fine;
END.
